# State-Machine Replication for Planet-Scale Systems (ATLAS)

EPaxos but......faster.

- fastpath quorum: *floor(n/2) + f*
- can *sometimes* use the fast path w/ concurrent non-commuting ops
- *always* fast path for *f=1*, fast path minimal majority
- faster non-fault-tolerant reads "when the conflict relation between commands is transitive". 

![protocol](atlasFig1.png)

## Protocol
![protocol](atlasProtocol.png)

## Fast Path Optimization

Statement:

**deps returned do not have to agree if each reported is reported by at least *f* respondents**.

For example, we can recover *D* at *f=2* after just fast path even w/ two failures:
1. One failure leaves at least one replica that reported the dep, so it will be seen afterwards. This takes us to *f-1*.
1. The other failure must be the coordinator, as no need to recover if coordinator doesn't go down. The coordinator appends any deps it knows initially to messages in the collect phase. Therefore, if the coordinator was one of the *f* that reported a specific dependency, the other particplants of the collect phase will know about it. This takes us to *f-2*.


## Examples

![protocol](atlasFig2.png)

How to distinguish 2a from this if (1) and (4) die?
![noC](atlasNoC.png)


## Recovery
![recovery](atlasRecovery.png)


## Issues
- "violating the assumption ...number of failures may only compromise liveness, but never safety"
  - assumes replicas recoverable
